@echo off
setlocal
set BF_CONFIG_NAME=%~1
if "%BF_CONFIG_NAME%"=="" set BF_CONFIG_NAME=Release
set BF_MSBUILD_OPTS=/p:Configuration=%BF_CONFIG_NAME% /v:quiet /clp:NoItemAndPropertyList
set BF_MSBUILD_CLEAN=/t:Clean %BF_MSBUILD_OPTS%
set BF_MSBUILD_BUILD=/t:Rebuild %BF_MSBUILD_OPTS%
set BF_TARGET_DIR=odct\bin\%BF_CONFIG_NAME%
rem set CodeContractsInstallDir=%~dp03rdPartyLibraries\Contracts\
rem echo CodeContractsInstallDir=%CodeContractsInstallDir%

if "%VS120COMNTOOLS%"=="" goto SET_ENV
echo.
call "%VS120COMNTOOLS%vsvars32.bat" x86

echo.
echo Removing all bin and obj directories...
for /D %%p in (*) do if exist "%%~p\bin\%BF_CONFIG_NAME%\." rd /q /s "%%~p\bin\%BF_CONFIG_NAME%"
for /D %%p in (*) do if exist "%%~p\obj\%BF_CONFIG_NAME%\." rd /q /s "%%~p\obj\%BF_CONFIG_NAME%"

echo Creating directory:  "%BF_TARGET_DIR%"
if not exist "%BF_TARGET_DIR%\." mkdir "%BF_TARGET_DIR%"
if errorlevel 1 goto FAIL

echo.
echo Cleaning odct solution
msbuild odct.sln %BF_MSBUILD_CLEAN%
if errorlevel 1 goto FAIL

echo.
echo Copying 3rdPartyLibraries
call Copy3rdPartyFiles.bat "odct\bin\%BF_CONFIG_NAME%"

echo.
echo Building odct solution
msbuild odct.sln %BF_MSBUILD_BUILD%
if errorlevel 1 goto FAIL

if not "%BF_CONFIG_NAME%"=="Release" goto FINISHED
echo.
echo.
echo.
echo Removing debug files from Release build
del "%BF_TARGET_DIR%\*.pdb"
del "%BF_TARGET_DIR%\*.xml"
del "%BF_TARGET_DIR%\*.config"
del "%BF_TARGET_DIR%\*.manifest"
del "%BF_TARGET_DIR%\*.application"


:FINISHED
echo.
echo.
echo.
echo Build completed successfully.
echo.
goto END

:FAIL
echo.
echo BUILD FAILED!
echo.
exit /B 1

:SET_ENV
echo.
echo ERROR: The environment variable VS120COMNTOOLS must be set!
echo.
exit /B 2

:END
endlocal
