﻿using NUnit.Framework;
using odct.Clusters;
using odct.Counters;
using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;

namespace odct.tests {
    [TestFixture]
    class ClusterMetaFileTests {

        ClusterMetaFile clusterMetaFile;
        string compressedFilename;

        [TestFixtureSetUp]
        public void init() {

            string uncompressedFilename = Path.GetTempFileName();
            compressedFilename = Path.GetTempFileName();
            File.WriteAllText(uncompressedFilename, "abcdefg</archive>1234567");
            FileStream uncompressedstream = new FileStream(uncompressedFilename, FileMode.Open, FileAccess.Read);
            FileStream compressedstream = new FileStream(compressedFilename, FileMode.Open, FileAccess.Write);
            GZipStream gzs = new GZipStream(compressedstream, CompressionMode.Compress);

            const int readBufferSize = 4096;
            byte[] buffer = new byte[readBufferSize];

            int read;
            while ((read = uncompressedstream.Read(buffer, 0, buffer.Length)) > 0) {
                gzs.Write(buffer, 0, read);
            };

            uncompressedstream.Dispose();
            gzs.Dispose();
            compressedstream.Dispose();
        }

        [Test]
        [Category("Unit")]
        public void canGetTextUpToBackSlashArchiveFor81cModeNode() {

            clusterMetaFile = new ClusterMetaFile(compressedFilename, "8.1");
//            string work = ArchiveParser.getArchiveXmlAsString(compressedFilename);
            Assert.AreEqual(17, clusterMetaFile.metaXml.Length);
            Assert.AreEqual("abcdefg</archive>", clusterMetaFile.metaXml);
        }


    }
}
