﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using NetApp.Manage;
using odct.FilerConfig;
using odct.Clusters;

namespace odct.tests {
    public class ClusterStub_8_3 : Cluster {

        public new string clusterContact { get; private set; }
        public new string clusterLocation { get; private set; }
        public new string clusterName { get; private set; }
        public new string clusterUuid { get; private set; }
        public new string clusterSerialNumber { get; private set; }
        public new string clusterRdbUuid { get; private set; }
        public new string clusterMgmtIp { get; private set; }
        public new string clusterHomeNode { get; private set; }

        public new int ontapGeneration { get; private set; }
        public new int ontapMajor { get; private set; }
        public new int ontapMinor { get; private set; }

        public new Credentials credentials { get; private set; }
        public new NaServer naServer { get; private set; }
        public new List<string> nodeNames { get; private set; }
        public new Dictionary<string, ClusterNode> nodeNamesToNodes { get; private set; }

        public new Messenger messenger { get; set; }
        public new string payloadPath { get; set; }
        public new string clusterPath { get; set; }
        public new string clusterConfigPath { get; set; }

        public ClusterStub_8_3() {
        }

        public new void getClusterIdentityInfo() {
            this.clusterContact = "";
            this.clusterLocation = "";
            this.clusterName = "";
            this.clusterSerialNumber = "";
            this.clusterUuid = "";
            this.clusterRdbUuid = "";

            this.clusterPath = Path.Combine(this.payloadPath, this.clusterUuid);
        }

        public new void getClusterOntapVersion() {
            this.ontapGeneration = 8;
            this.ontapMajor = 2;
            this.ontapMinor = 1;
        }

        public new void getNodes() {
        }

        public void Collect() {
        }

        public new void CollectClusterConfiguration() {
        }

        public new void SaveClusterConfig() {
        }
    }
}
