﻿using System;
using System.Collections.Generic;
using System.IO;
using NUnit.Framework;
using odct;
using odct.Clusters;

namespace odct.tests {
    [TestFixture]
    [Category("BrokenTests")]
    // These tests work from nunit-x86.exe
    public class CmaplGetCounterNamesTests {

        public string filepath;

        [TestFixtureSetUp]
        public void init() {
            filepath = Path.Combine(OdctSettingsTest.GetRelativeUnitTestDataDirectory("cmode84"), "043311_003600_1462991400454_0899000.ccma");
            CmaplWrapper.LoadDllsIfNecessary();   // It seems like this should be necessary, but runs fine without it!
        }

        [Test]
        public void canGetCounterNames() {

            var infilePath = filepath;
            string objectName = "system";
            Int32[] frequency = {5000, 60000};

            string result = CmaplWrapper.GetCounterNames(
				infilePath,
				objectName,
				frequency,
                new MessengerStub(),
                "");

            Console.WriteLine(result);

            var expected = "system_ops,net_data_recv,net_data_sent,fcp_data_recv,fcp_data_sent"
                + ",iscsi_data_recv,iscsi_data_sent,partner_data_recv,partner_data_sent"
                + ",disk_data_read,disk_data_written,hdd_data_read,hdd_data_written,ssd_data_read"
                + ",ssd_data_written,tape_data_read,tape_data_written,total_ops,cpu_busy,cpu_elapsed_time"
                + ",avg_processor_busy,total_processor_busy,total_processor_busy_time,domain_busy";

            Assert.AreEqual(expected, result);
        }

    }
}
