﻿using NUnit.Framework;
using odct;
using System.Collections.Generic;

namespace odct.tests
{
    [TestFixture]
    class ConnectionInteractorTests
    {
        [Test]
        public void VerifyConnectionCallsInterfaceWithProperCredentials()
        {
            FilerSpyWithValidCredentials f = new FilerSpyWithValidCredentials();
            ConnectionInteractor ci = new ConnectionInteractor(f);
            Credentials fc = new Credentials("server", "username", "password");
            List<string> expectedCalls = new List<string>();
            expectedCalls.Add("VerifyConnection called with server username password");
            bool verifyResult = ci.VerifyConnection(fc);

            Assert.IsTrue(verifyResult);
            Assert.That(f.getMethodCalls(), Is.EqualTo(expectedCalls));
        }
    }
}
