﻿using System;
using System.Collections.Generic;
using NUnit.Framework;

namespace odct.tests.Counters {
    [TestFixture]
    public class ArchiveParserLogicTests {
        public struct meta { public uint flag; public uint id; public uint size;};
        public static List<meta> testmeta = new List<meta> {
            new meta() { flag = 0x08, id = 0, size = 2},
            new meta() { flag = 0x01, id = 1, size = 4},
            new meta() { flag = 0x02, id = 2, size = 4},
            new meta() { flag = 0x02, id = 3, size = 4}
        };

        public Dictionary<uint, uint> GetOffsetsForInstanceRecord(uint instanceFlag) {
            // CounterDefinitionCollector just be should doing this

            var result = new Dictionary<uint, uint>(); // should this be a dictionary, or just an array with all ids?
            //for (int i = 0; i < testmeta.Count; i++) { ... do we even need id if they're all there and in order?
            uint offset = 0;
            foreach (var m in testmeta) {
                if ((m.flag & instanceFlag) > 0) {
                    result.Add(m.id, offset);
                    offset += m.size;
                }
            }

            return result;
        }

        [Test]
        [Category("Unit")]
        public void canGetOffsetsForInstanceRecord() {
            var a = GetOffsetsForInstanceRecord(0x01);
            var b = GetOffsetsForInstanceRecord(0x02);
            var c = GetOffsetsForInstanceRecord(0x03);
            var d = GetOffsetsForInstanceRecord(0x08);
            var e = GetOffsetsForInstanceRecord(0x09);
            Assert.NotNull(a);
        }

    }
}
