using System;
using System.Collections.Generic;
using NUnit.Framework;
using odct.Counters;

namespace odct.tests.Counters {
    [TestFixture]
    [Category("Unit")]
    public class CTypeTests {


        [Test]
        public void canDetermineIfCounterIsString() {
            // system ctypes
            Assert.IsFalse(new CType(66568).isString());  // system histograms
            Assert.IsTrue(new CType(73744).isString());   // serial_no
            Assert.IsTrue(new CType(73792).isString());   // system_id, hostname
            Assert.IsTrue(new CType(73980).isString());   // ontap_version
            Assert.IsFalse(new CType(131592).isString()); // "_ops" counters, e.g., cifs_ops
            Assert.IsFalse(new CType(200712).isString()); // "_busy" counters, e.g., cpu_busy
            Assert.IsFalse(new CType(328200).isString()); // ".. per second" counters, e.g., net_data_recv
            Assert.IsFalse(new CType(721928).isString()); // "_elapsed_timex" counters

            // volume cytpes
            Assert.IsTrue(new CType(73792).isString());   // parent_aggr
            Assert.IsFalse(new CType(131592).isString());  // number of ops, reads, writes
            Assert.IsFalse(new CType(262664).isString());  // bytes read or written
            Assert.IsFalse(new CType(460808).isString());  // latencies, average times
        }


    }
}
