﻿namespace odct.tests.Counters {
    using NUnit.Framework;
    using System;
    using System.IO;
    using odct.Counters;

    [TestFixture]
    class CounterDefinitionLookupTests {
        CounterDefinitionLookup systemObject;
        string xmlContent;

        [TestFixtureSetUp]
        public void init() {
            var metaXmlPath = Path.Combine(
                OdctSettingsTest.GetRelativeUnitTestDataDirectory("ontap73"),
                "stats_archive_data_1447684431_20151116_093351.xml");

            var work = TestContext.CurrentContext.WorkDirectory;
            this.xmlContent = File.ReadAllText(metaXmlPath);
            this.systemObject = new CounterDefinitionLookup(
                this.xmlContent, 
                "system");
        }

        [Test, Description("")]
        [Category("Unit")]
        public void canGetCounterDetail() {
            var nfs_ops = this.systemObject.GetCounterDefinitionByCounterName("nfs_ops");
            this.systemObject.GetCounterDefinitionByCounterName("nfs_ops");
            Assert.NotNull(nfs_ops);

            var byId = this.systemObject.GetCounterDefinitionByCounterId(nfs_ops.id);
            Assert.AreEqual(nfs_ops, byId);
        }

        [Test, Description("")]
        [Category("Unit")]
        public void canGetObjectDetail() {
            Assert.AreEqual("system", this.systemObject.ObjectName);
            Assert.AreEqual(0, this.systemObject.Oid);
        }

        [Test, Description("")]
        [Category("Unit")]
        public void canGetOffsetOnInstanceFlag() {
            Assert.AreEqual("system", this.systemObject.ObjectName);
            var nfs_ops = this.systemObject.GetCounterDefinitionByCounterName("nfs_ops");
            var sorted = this.systemObject.GetCounterDefinitionListSortedByCounterId();
            //// DELETE-ME var offset = this.systemObject.GetOffsetsForInstanceRecord((uint) 2097152)[nfs_ops.id];

            Assert.AreEqual(24, sorted.Count);
        }
    }
}
