using System;
using System.Collections.Generic;
using NUnit.Framework;
using odct.Counters;

namespace odct.tests.Counters {
    [TestFixture]
    [Category("Unit")]
    public class FlagTests {


        [Test]
        public void canGetConfigFlagFromLong() {
            Assert.IsTrue((new Flag((long) 131072)).configflag);  // CONFIG flag (only) is true
            Assert.IsFalse((new Flag((long) 262144)).configflag);  // FREQUENCY_1 flag (only) is true
            Assert.IsFalse((new Flag((long) 524288)).configflag);  // FREQUENCY_2 flag (only) is true
            Assert.IsFalse((new Flag((long) 1048576)).configflag); // FREQUENCY_3 flag (only) is true
            Assert.IsFalse((new Flag((long) 2097152)).configflag); // FREQUENCY_4 flag (only) is true
        }

        [Test]
        public void canGetFrequency1FlagFromLong() {
            Assert.IsFalse((new Flag((long) 131072)).freq1flag);  // CONFIG flag (only) is true
            Assert.IsTrue((new Flag((long) 262144)).freq1flag);  // FREQUENCY_1 flag (only) is true
            Assert.IsFalse((new Flag((long) 524288)).freq1flag);  // FREQUENCY_2 flag (only) is true
            Assert.IsFalse((new Flag((long) 1048576)).freq1flag); // FREQUENCY_3 flag (only) is true
            Assert.IsFalse((new Flag((long) 2097152)).freq1flag); // FREQUENCY_4 flag (only) is true
        }

        [Test]
        public void canGetFrequency2FlagFromLong() {
            Assert.IsFalse((new Flag((long) 131072)).freq2flag);  // CONFIG flag (only) is true
            Assert.IsFalse((new Flag((long) 262144)).freq2flag);  // FREQUENCY_1 flag (only) is true
            Assert.IsTrue((new Flag((long) 524288)).freq2flag);  // FREQUENCY_2 flag (only) is true
            Assert.IsFalse((new Flag((long) 1048576)).freq2flag); // FREQUENCY_3 flag (only) is true
            Assert.IsFalse((new Flag((long) 2097152)).freq2flag); // FREQUENCY_4 flag (only) is true
        }

        [Test]
        public void canGetFrequency3FlagFromLong() {
            Assert.IsFalse((new Flag((long) 131072)).freq3flag);  // CONFIG flag (only) is true
            Assert.IsFalse((new Flag((long) 262144)).freq3flag);  // FREQUENCY_1 flag (only) is true
            Assert.IsFalse((new Flag((long) 524288)).freq3flag);  // FREQUENCY_2 flag (only) is true
            Assert.IsTrue((new Flag((long) 1048576)).freq3flag); // FREQUENCY_3 flag (only) is true
            Assert.IsFalse((new Flag((long) 2097152)).freq3flag); // FREQUENCY_4 flag (only) is true
        }

        [Test]
        public void canGetFrequency4FlagFromLong() {
            Assert.IsFalse((new Flag((long) 131072)).freq4flag);  // CONFIG flag (only) is true
            Assert.IsFalse((new Flag((long) 262144)).freq4flag);  // FREQUENCY_1 flag (only) is true
            Assert.IsFalse((new Flag((long) 524288)).freq4flag);  // FREQUENCY_2 flag (only) is true
            Assert.IsFalse((new Flag((long) 1048576)).freq4flag); // FREQUENCY_3 flag (only) is true
            Assert.IsTrue((new Flag((long) 2097152)).freq4flag); // FREQUENCY_4 flag (only) is true
        }

    }
}
