using System;
using System.Diagnostics;
using System.Text;
using System.Collections.Generic;
using System.IO;
using NUnit.Framework;
using odct.Counters;
using odct.Settings;

namespace odct.tests.Counters {

    [TestFixture]
    [Category("Integration")]
    public class ZapiArchiveFileSourceTests {
        ZapiContext zc;
        Messenger m;
        string hostsString;
        byte[] hostsByteArray;

        [TestFixtureSetUp]
        public void init() {

            m = new MessengerStub();

            Credentials testCredentials = new Credentials("10.61.96.150", "root", "cpoc964");
            testCredentials.Verify(m);

            zc = new ZapiContext(testCredentials, m, NetApp.Manage.NaServer.TRANSPORT_TYPE.HTTPS);
            zc.initializeServer();
            hostsString = "#Auto-generated by setup Wed Dec  8 16:35:36 EST 2010\n"  // 54 characters
                + "127.0.0.1 localhost\n"                                         // 20 characters, 74 cumulatively
                + "# 0.0.0.0       sylvester-e0M\n"                               // 30 characters, 104 cumulatively
                + "10.61.96.150    sylvester sylvester-e0a\n"                     // 40 characters, 144 cumulatively
                + "# 0.0.0.0       sylvester-e0b\n"                               // 30 characters, 174 cumulatively
                + "10.61.100.71\tfarcry\tfarcry.cpoc.netapp.com\n";               // 43 characters, 217 cumulatively
            hostsByteArray = Encoding.ASCII.GetBytes(hostsString);
        }

        [Test]
        public void CanReadFileUsingBatchZapi() {
            Assert.AreEqual(hostsByteArray, ZapiArchiveFileSource.zapiBatchReadAllBytes("/vol/vol0/etc/hosts", zc));
        }

    }
}
