using System;
using System.Diagnostics;
using System.Text;
using System.Collections.Generic;
using System.IO;
using System.Text.RegularExpressions;
using NUnit.Framework;
using odct.Counters;
using odct.Settings;
using NetApp.Manage;

namespace odct.tests.Counters {

    [TestFixture]
    [Category("Integration")]
    public class ZapiSourceGeneratorTests {
        ZapiContext zc;
        Messenger m;
        Credentials testCredentials;

        [TestFixtureSetUp]
        public void init() {

            m = new MessengerStub();

            testCredentials = new Credentials("10.26.129.26", "root", "password1");
            testCredentials.Verify(m);

            zc = new ZapiContext(testCredentials, m, NaServer.TRANSPORT_TYPE.HTTPS);
            zc.initializeServer();
        }

        [Test]
        public void CanGetArchiveDirectoryFileListWithGetSources() {

            ZapiSourceGenerator zsg = new ZapiSourceGenerator("", zc);
            string firstFromGetFilenames = zsg.GetFilenames()[0];

            IEnumerable<ArchiveFileSource> ie_afs = zsg.GetSources();
            IEnumerator<ArchiveFileSource> enumerator = ie_afs.GetEnumerator();
            enumerator.MoveNext();
            ArchiveFileSource afs = enumerator.Current;
            Assert.AreEqual(firstFromGetFilenames, afs.Filename);

        }

    }
}
