using System;
using System.Collections.Generic;
using NUnit.Framework;
using odct;

namespace odct.tests {
    [TestFixture]
    [Category("Unit")]
    public class ExtensionMethodTests {

        [Test]
        public void canGetSubArray() {
            byte[] b = new byte[12] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
            byte[] newArray = b.getSubArray(2, 3);
            Assert.AreEqual(new byte[3] { 3, 4, 5 }, newArray);
        }

        [Test]
        public void canGetByte() {
            byte[] b = new byte[12] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
            byte c = b.getByte(3);
            Assert.AreEqual(4, c);
        }

        [Test]
        public void canGetBitFromByte() {
            byte b = 14;
            Assert.AreEqual(false, b.getBit(0));    // 1's
            Assert.AreEqual(true, b.getBit(1));     // 2's
            Assert.AreEqual(true, b.getBit(2));     // 4's
            Assert.AreEqual(true, b.getBit(3));     // 8's
            Assert.AreEqual(false, b.getBit(4));
            Assert.AreEqual(false, b.getBit(5));
            Assert.AreEqual(false, b.getBit(6));
            Assert.AreEqual(false, b.getBit(7));
        }

        [Test]
        public void canGetBitFromLong() {
            const long long1 = 211080;  // hex 33888
            Assert.AreEqual(false, long1.getBit(15));    // 
            Assert.AreEqual(true, long1.getBit(16));    // 
            Assert.AreEqual(true, long1.getBit(17));    // CONFIG
            Assert.AreEqual(false, long1.getBit(18));    // FREQUENCY_1
            Assert.AreEqual(false, long1.getBit(19));    // FREQUENCY_2
            Assert.AreEqual(false, long1.getBit(20));    // FREQUENCY_3
            Assert.AreEqual(false, long1.getBit(21));    // FREQUENCY_4
            Assert.AreEqual(false, long1.getBit(22));    // 
            const long long2 = 2177160;  // hex 213888
            Assert.AreEqual(false, long2.getBit(15));    // 
            Assert.AreEqual(true, long2.getBit(16));    // 
            Assert.AreEqual(false, long2.getBit(17));    // CONFIG
            Assert.AreEqual(false, long2.getBit(18));    // FREQUENCY_1
            Assert.AreEqual(false, long2.getBit(19));    // FREQUENCY_2
            Assert.AreEqual(false, long2.getBit(20));    // FREQUENCY_3
            Assert.AreEqual(true, long2.getBit(21));    // FREQUENCY_4
        }
    }
}
