﻿namespace odct.tests {
    using System;
    using System.IO;
    using NUnit.Framework;

    [TestFixture]
    class PayloadTest {

        [Test]
        [Category("Unit")]
        public void CompressDir() {
            var p = OdctSettingsTest.GetRelativeUnitTestDataDirectory();

            Payload.Zip(p, Path.Combine(
                TestContext.CurrentContext.TestDirectory,
                "compress-test.zip"));
        }

        [Test]
        [Category("Unit")]
        public void GetParent() {
            var d = TestContext.CurrentContext.TestDirectory;
            Assert.That(!Path.HasExtension(d));

            var f = Path.Combine(
                TestContext.CurrentContext.TestDirectory,
                "compress-test.zip");
            Assert.That(Path.HasExtension(f));

            var p = Directory.GetParent(f).ToString();
            Assert.AreEqual(p, d);
        }

        [Test]
        [Category("Unit")]
        public void ItsOkToToTryToCreateAPathThatAlreadyExists() {
            var d = TestContext.CurrentContext.TestDirectory;
            Assert.That(Directory.Exists(d));
            Directory.CreateDirectory(d);
        }
    }
}
