﻿namespace odct.Clusters {
    using System;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterCli: Section{
        public const string ZapiCommand = "system-cli";
        private string cliCommand;

        public ClusterCli(string cmd, Credentials c, Messenger m) : base(c, m) {
            this.cliCommand = cmd;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var zapiCommand = ZapiCommand;
            this.messenger.sendDebug(string.Format("...GetNaElement(\"{0}\") {1} started.", zapiCommand, this.cliCommand));

            var api = new NaElement(ZapiCommand);
			NaElement argsElement = new NaElement("args");
            argsElement.AddNewChild("arg", this.cliCommand);
            api.AddChildElement(argsElement);

            return this.SafeInvokeElement(api);
        }

        // TODO: only want to customize GetSectionTitle but abstract GetZapiCommandString is required
        public override string GetZapiCommandString() {

            return string.Format("{0}-{1}", ZapiCommand, this.cliCommand.Replace(" -","-").Replace(" ", "-").Replace("*", "all"));
        }
    }
}
