﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using odct.Counters;

namespace odct.Clusters {
    public class ClusterMetaFile {

        private string filepath;
        public string metaXml { get; private set; }

        public ClusterMetaFile (string ccmaFilePath, string MajorVersion) {

            if (MajorVersion.Equals("8.1")) {

                this.filepath = ccmaFilePath;  // on 8.1 c-mode filers, the "ccma" path does not include ".ccma" but does include ".gz"
                const int readBufferSize = 4096;

                FileStream infilestream = new FileStream(this.filepath, FileMode.Open, FileAccess.Read);
                GZipStream gzs = new GZipStream(infilestream, CompressionMode.Decompress);

                string tempfilename = Path.GetTempFileName();
                FileStream outfilestream = new FileStream(tempfilename, FileMode.Open, FileAccess.Write);

                byte[] buffer = new byte[readBufferSize];

                int read;
                while ((read = gzs.Read(buffer, 0, buffer.Length)) > 0 ) {
                    outfilestream.Write (buffer, 0, read);
                };

                infilestream.Dispose();
                outfilestream.Dispose();
                gzs.Dispose();
                this.metaXml = ArchiveParser.getArchiveXmlAsString(tempfilename);
                File.Delete(tempfilename);

            } else {
                this.filepath = ccmaFilePath + ".meta";
                this.metaXml = ArchiveParser.getArchiveXmlAsString(this.filepath);
            };
        }


    }
}
