﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterNodeFcpAdapterGetIter: Section {
        private string nodeName;

        public ClusterNodeFcpAdapterGetIter(Credentials c, Messenger m, ClusterNode cn)
            : base(c, m) {
            this.nodeName = cn.nodeName;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {

            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("max-records", "9999");

        	NaElement queryElement = new NaElement("query");
        	api.AddChildElement(queryElement);

        	NaElement fcpconfigadapterinfoElement = new NaElement("fcp-adapter-get-iter");
            queryElement.AddChildElement(fcpconfigadapterinfoElement);
            fcpconfigadapterinfoElement.AddNewChild("home-node", this.nodeName);

            return this.SafeInvokeElement(api);
        }

        public override string GetZapiCommandString() {
            return "fcp-adapter-get-iter";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}", this.GetZapiCommandString());
        }
    }
}
