﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterNodeNetInterfaceGetIter: Section {
        private string nodeName;

        public ClusterNodeNetInterfaceGetIter(Credentials c, Messenger m, ClusterNode cn)
            : base(c, m) {
            this.nodeName = cn.nodeName;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {

            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("max-records", "2000");

        	NaElement queryElement = new NaElement("query");
        	api.AddChildElement(queryElement);

        	NaElement netinterfaceinfoElement = new NaElement("net-interface-info");
        	queryElement.AddChildElement(netinterfaceinfoElement);
        	netinterfaceinfoElement.AddNewChild("home-node", this.nodeName);

            return this.SafeInvokeElement(api);
        }

        public override string GetZapiCommandString() {
            return "net-interface-get-iter";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}", this.GetZapiCommandString());
        }
    }
}
