﻿namespace odct.Clusters {
    using odct.FilerConfig;
    using System;
    using NetApp.Manage;

    public class ClusterNodeOptionsListInfo : Section {
        public string Name { get; private set; }
        private ClusterNode thisClusterNode;

        public ClusterNodeOptionsListInfo(ClusterNode cn, Credentials c, Messenger m)
            : base(c, m) {
            this.thisClusterNode = cn;
            this.FinishConstructor();
        }

        public override string GetZapiCommandString() {
            return "options-list-info";
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            this.credentials.naServer.SetVfilerTunneling(this.thisClusterNode.nodeName);
            this.messenger.sendDebug(string.Format("Trying node vserver {0}", this.thisClusterNode.nodeName));
            NaElement xo = this.SafeInvokeElement(api);
            this.credentials.resetVfilerTunneling();
            return xo;
        }
    }
}
