﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterNodeStorageDiskGetIter: Section {
        private string nodeName;

        public ClusterNodeStorageDiskGetIter(Credentials c, Messenger m, ClusterNode cn)
            : base(c, m) {
            this.nodeName = cn.nodeName;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {

            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("max-records", "2000");

        	NaElement queryElement = new NaElement("query");
        	api.AddChildElement(queryElement);

        	NaElement storagediskinfoElement = new NaElement("storage-disk-info");
            queryElement.AddChildElement(storagediskinfoElement);

            NaElement diskownershipinfoElement = new NaElement("disk-ownership-info");
            storagediskinfoElement.AddChildElement(diskownershipinfoElement);

            diskownershipinfoElement.AddNewChild("owner-node-name", this.nodeName);

            return this.SafeInvokeElement(api);
        }

        public override string GetZapiCommandString() {
            return "storage-disk-get-iter";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}", this.GetZapiCommandString());
        }
    }
}
