﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterNodeSystemGetNodeInfoIter: Section {
        private string nodeName;

        public ClusterNodeSystemGetNodeInfoIter(Credentials c, Messenger m, ClusterNode cn)
            : base(c, m) {
            this.nodeName = cn.nodeName;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {

            var api = new NaElement(this.GetZapiCommandString());

        	NaElement queryElement = new NaElement("query");
        	api.AddChildElement(queryElement);

        	NaElement systeminfoElement = new NaElement("system-info");
            queryElement.AddChildElement(systeminfoElement);
            systeminfoElement.AddNewChild("system-name", this.nodeName);

            return this.SafeInvokeElement(api);
        }

        public override string GetZapiCommandString() {
            return "system-get-node-info-iter";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}", this.GetZapiCommandString());
        }
    }
}
