﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterStorageAdapterGetAdapterInfo : Section {
        public string AdapterName;
        public string NodeName;

        public ClusterStorageAdapterGetAdapterInfo(Credentials c, Messenger m, NodeAdapterPair na)
            : base(c, m) {
            this.NodeName = na.nodeName;
            this.AdapterName = na.adapterName;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("adapter-name", this.AdapterName);
            api.AddNewChild("node-name", this.NodeName);
            var xo = this.credentials.naServer.InvokeElem(api);
            return xo;
        }

        public override string GetZapiCommandString() {
            return "storage-adapter-get-adapter-info";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}-{1}-{2}", this.GetZapiCommandString(), this.NodeName, this.AdapterName);
        }
    }
}
