﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterStorageAdapterGetAdapterList : Section {
        public IEnumerable<NodeAdapterPair> NodeAdapterPairs;

        public ClusterStorageAdapterGetAdapterList(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement adapterListElement = this.naElement.GetChildByName("adapter-list");
            List<NaElement> adapterNameElements = adapterListElement.GetChildren();

            var nodeAdapterPairs = new List<NodeAdapterPair>();
            foreach (NaElement adapterNameElement in adapterNameElements) {
                string node = adapterNameElement.GetChildContent("node-name");
                string adapter = adapterNameElement.GetChildContent("adapter-name");
                nodeAdapterPairs.Add(new NodeAdapterPair(node, adapter));                    
            }
            this.NodeAdapterPairs = nodeAdapterPairs;
        }

        public override string GetZapiCommandString() {
            return "storage-adapter-get-adapter-list";
        }
    }
}
