﻿namespace odct.Clusters {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterVolumeGetIter : Section {
        public IEnumerable<VolumeVServerPair> volumeVServerPairs;

        public ClusterVolumeGetIter(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement attributesListElement = this.naElement.GetChildByName("attributes-list");
            List<NaElement> volumeAttributesElements = attributesListElement.GetChildren();

            var volumeVServerPairs = new List<VolumeVServerPair>();
            foreach (NaElement volumeAttributesElement in volumeAttributesElements) {
                NaElement volumeIdAttributesElement = volumeAttributesElement.GetChildByName("volume-id-attributes");
                string volName = volumeIdAttributesElement.GetChildContent("name");
                string vserverName = volumeIdAttributesElement.GetChildContent("owning-vserver-name");
                if (!"vol0".Equals(volName)) {
                    volumeVServerPairs.Add(new VolumeVServerPair(volName, vserverName));
                }
            }
            this.volumeVServerPairs = volumeVServerPairs;
        }

        protected override NaElement Process(string specificZapiCommand = null) {

            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("max-records", "9999");

            return this.SafeInvokeElement(api);
        }

        public override string GetZapiCommandString() {
            return "volume-get-iter";
        }
    }
}
