﻿namespace odct.Clusters {
    using System;
    using System.Collections.Generic;
    using NetApp.Manage;
    using odct.FilerConfig;

    public class ClusterVolumeOptionsListInfo : Section {
        public string VolumeName;
        public string VServerName;

        public ClusterVolumeOptionsListInfo(Credentials c, Messenger m, VolumeVServerPair vv)
            : base(c, m) {
            this.VolumeName = vv.volumeName;
            this.VServerName = vv.vserverName;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            this.credentials.naServer.SetVfilerTunneling(this.VServerName);
            api.AddNewChild("volume", this.VolumeName);
            this.messenger.sendDebug(string.Format("Trying volume {0}", this.VolumeName));
            NaElement xo = this.SafeInvokeElement(api);
            this.credentials.resetVfilerTunneling();
            return xo;
        }

        public override string GetZapiCommandString() {
            return "volume-options-list-info";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}-{1}-{2}", this.GetZapiCommandString(), this.VServerName, this.VolumeName);
        }
    }
}
