﻿namespace odct {
    using System;
    using System.Diagnostics;
    using System.Globalization;
    using System.Collections.Generic;

    public class ConsoleUI : Messenger {
        messageLevels level = messageLevels.warning;
        public ConsoleUI(messageLevels ml) {
            this.level = ml;
        }

        private static void sendMessage(string message, string prefix, ConsoleColor color) {
            Console.ForegroundColor = color;
            Console.WriteLine(string.Format("{0} - {1} - {2}", timeNow(), prefix, message));
            Console.ResetColor();
        }

        public static void WriteDebug(string message) {
            sendMessage(message, "Debug", ConsoleColor.Cyan);
        }

        public static void WriteInfo(string message) {
            sendMessage(message, "Info", ConsoleColor.White);
        }

        public static void WriteWarning(string message) {
            sendMessage(message, "Warning", ConsoleColor.Yellow);
        }

        public static void WriteError(string message) {
            sendMessage(message, "Error", ConsoleColor.Red);
        }

        public override void sendDebug(string message) {
            if (this.level <= messageLevels.debug) {
                WriteDebug(message);
            }
        }

        public override void sendInfo(string message) {
            if (this.level <= messageLevels.info) {
                WriteInfo(message);
            }
        }

        public override void sendWarning(string message) {
            if (this.level <= messageLevels.warning) {
                WriteWarning(message);
            }
        }

        public override void sendError(string message) {
            WriteError(message);
        }

    }

}
