﻿using System;
using System.Collections.Generic;
using System.Text;

namespace odct.Counters {
    public class CType {

        public long cTypeValue { get; set; }

        // counter size constants
        public const long CM_CNT_4B = 0x00000004L;
        public const long CM_CNT_8B = 0x00000008L;
        public const long CM_CNT_16B = 0x00000010L;
        public const long CM_CNT_32B = 0x00000020L;
        public const long CM_CNT_64B = 0x00000040L;
        public const long CM_CNT_96B = 0x00000060L;
        public const long CM_CNT_128B = 0x00000080L;
        public const long CM_CNT_160B = 0x000000A0L;
        public const long CM_CNT_252B = 0x000000FCL;

        // processing type constants
        public const long CM_CNT_RAW = 0x00000100L; /* C2 */
        public const long CM_CNT_RATE = 0x00000200L; /* (C2 - C1) / timediff */
        public const long CM_CNT_DELTA = 0x00000400L; /* C2 - C1 */
        public const long CM_CNT_PERCT = 0x00001000L; /* Scalable (C2-C1) / base diff */
        public const long CM_CNT_STRING = 0x00002000L;
        public const long CM_CNT_TYPE_MASK = 0x0000FF00L;

        // suffix constants
        public const long CM_NO_SUFFIX = 0x00010000L;
        public const long CM_PER_SEC = 0x00020000L;
        public const long CM_PERCT = 0x00030000L; /* % */
        public const long CM_B_PER_SEC = 0x00040000L;
        public const long CM_KB_PER_SEC = 0x00050000L;
        public const long CM_MSECS = 0x00060000L;
        public const long CM_USECS = 0x00070000L;
        public const long CM_SECS = 0x00080000L;
        public const long CM_MB_PER_SEC = 0x00090000L;
        public const long CM_MB = 0x000A0000L;
        public const long CM_CNT_NODISP = 0x000B0000L;

        public CType(long ct) {
            cTypeValue = ct;
        }

        public bool isString() {
            return ((cTypeValue & CM_CNT_STRING) > 0);
        }

    }
}
