using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using odct.Clusters;

namespace odct.Counters {
    public class Cluster81ArchiveFileSource: ArchiveFileSource {

        ClusterNode clusterNode;
        string fileName;
        string localPath;
        string spiPath;
        Messenger messenger;

        public Cluster81ArchiveFileSource(ClusterNode cn, string filename) {
            this.clusterNode = cn;
            this.fileName = filename;  // filename includes ".gz"
            this.messenger = this.clusterNode.messenger;
        }

        public override byte[] ReadAsBytes() {

            this.messenger.sendDebug(string.Format("ClusterNode {0} Cluster81ArchiveFileSource ReadAsBytes started.", this.clusterNode.nodeName));
            this.messenger.sendDebug(string.Format("ClusterNode {0} ... filename is {1}", this.clusterNode.nodeName, this.fileName));
            this.localPath = System.IO.Path.Combine(this.clusterNode.getLocalArchiveDirectory(), this.fileName);
            this.spiPath = string.Format("http://{0}/spi/{1}/etc/log/stats/archive/{2}",
                    this.clusterNode.nodeMgmtIp,
                    this.clusterNode.nodeName,
                    this.fileName);
            this.clusterNode.copySpiFileToLocal(this.spiPath, this.localPath);
            byte[] allBytes = File.ReadAllBytes(this.localPath);
            return ArchiveFileSource.ReadGZippedByteArrayAsBytes(allBytes);
        }

        public void deleteLocalFile() {
            File.Delete(this.localPath);
        }
    }
}
