using System;
using System.Collections.Generic;

namespace odct.Counters {
    public class CounterInstance {

        private byte[] allBytes;
        public CType ctype { get; set; }
        private byte[] counterBytes;
        private int counterLength;

        public CounterInstance(ref byte[] allBytes, long ctype, int counterStart, int counterLength) {
            this.allBytes = allBytes;
            this.ctype = new CType(ctype);
            this.counterLength = counterLength;
            this.counterBytes = allBytes.getSubArray(counterStart, counterLength);
        }

        public static string nullTerminatedBytesAsString(byte[] inputArray) {            
            var firstZero = inputArray.Length;
            for (int i = 0; i < inputArray.Length; i++) {
                if (inputArray[i] == 0) {
                    firstZero = i;
                    break;
                }
            }
            if (firstZero < inputArray.Length) {
                byte[] newBytes = inputArray.getSubArray(0, firstZero);
                return System.Text.ASCIIEncoding.ASCII.GetString(newBytes);
            } else {
                return System.Text.ASCIIEncoding.ASCII.GetString(inputArray);
            }
        }

        public string CounterAsString {
            get {
                if (this.ctype.isString()) {
                    return nullTerminatedBytesAsString(counterBytes);
                } else {
                    return this.CounterAsUInt64.ToString();
                }
            }
        }

        private UInt64 CounterAsUInt64 {
            get {
                return counterBytes.getBytesAsUInt64(0, this.counterLength);
            }
        }

    }
}
