﻿using System;
using System.Collections.Generic;
using System.Text;
using odct.Settings;

namespace odct.Counters {
    public class InstanceHeader {

        private byte[] allBytes;
        private int currentRecordStart;

        public InstanceHeader(ref byte[] allBytes, int currentRecordStart) {
            this.allBytes = allBytes;
            this.currentRecordStart = currentRecordStart;
        }

        public long msecs_since_boot {
            get { return (long) allBytes.getBytesAsUInt64(currentRecordStart + 0, 8); }
        }

        public long instance_size {
            get { return (long) allBytes.getBytesAsUInt64(currentRecordStart + 8, 4); }
        }

        public long oid {
            get { return (long) allBytes.getBytesAsUInt64(currentRecordStart + 12, 4); }
        }

        public long num_instances {
            get { return (long) allBytes.getBytesAsUInt64(currentRecordStart + 16, 4); }
        }

        public Flag instanceFlag {
            get { return new Flag((long) allBytes.getBytesAsUInt64(currentRecordStart + 20, 4)); }
        }

        public bool configflag {
            get { return this.instanceFlag.configflag; }
        }

        public bool freq1flag {
            get { return this.instanceFlag.freq1flag; }
        }

        public bool freq2flag {
            get { return this.instanceFlag.freq2flag; }
        }

        public bool freq3flag {
            get { return this.instanceFlag.freq3flag; }
        }

        public bool freq4flag {
            get { return this.instanceFlag.freq4flag; }
        }
    }
}
