using System;
using System.Collections;
using System.Collections.Generic;

namespace odct {
    public static class ExtensionMethods {

        public static byte[] getSubArray(this byte[] inputArray, int start, int length) {
            byte[] result = new byte[length];
            Array.Copy(inputArray, start, result, 0, length);
            return result;
        }

        public static byte getByte(this byte[] inputArray, int start) {
            return inputArray[start];
        }

        public static bool getBit(this byte inputByte, int bitPosition) {

            BitArray b = new BitArray(new byte[] { inputByte });
            return b[bitPosition];
        }

        public static bool getBit(this long inputLong, int bitPosition) {
            byte[] inputLongAsByteArray = BitConverter.GetBytes(inputLong);
            BitArray b = new BitArray(inputLongAsByteArray);
            return b[bitPosition];
        }

        public static UInt64 getBytesAsUInt64(this byte[] buffer, int start, int length) {
            byte[] work = new byte[8];

            for (int i = 0; i < 7; i++) {
                work[i] = 0;
            }

            for (int i = 0; i < length; i++) {
                work[i] = buffer[start + i];
            }

            return BitConverter.ToUInt64(work, 0);
        }

        public static bool Contains(this byte[] buffer, ref byte[] sequence, out int position) {
            int currOffset = 0;

            for (position = 0; position < buffer.Length; position++) {
                byte b = buffer[position];
                if (b == sequence[currOffset]) {
                    if (currOffset == sequence.Length - 1)
                        return true;
                    currOffset++;
                    continue;
                }

                // Fixup the offset to the byte after the beginning of the abortive sequence
                if (currOffset == 0)
                    continue;
                position -= currOffset;
                currOffset = 0;
            }

            return false;
        }
    }
}
