﻿namespace odct.FilerConfig {
    using System;
    using System.Collections.Generic;
    using NetApp.Manage;

    public class AggregatesAggrGetIter : Section {
        public IEnumerable<string> AggregateNames;

        public AggregatesAggrGetIter(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement attributesList = this.naElement.GetChildByName("attributes-list");
            List<NaElement> aggrAttributes = attributesList.GetChildren();

            var aggregateNames = new List<string>();
            foreach (NaElement aggrAttribute in aggrAttributes) {
                aggregateNames.Add(aggrAttribute.GetChildContent("aggregate-name"));
            }

            this.AggregateNames = aggregateNames;
                
        }

        public override string GetZapiCommandString() {
            return "aggr-get-iter";
        }
    }
}
