﻿namespace odct.FilerConfig {
    using System;
    using System.Collections.Generic;
    using NetApp.Manage;

    public class AggregatesGetAggregateList : Section {
        public IEnumerable<string> AggregateNames;

        public AggregatesGetAggregateList(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement aggregatesElement = this.naElement.GetChildByName("aggregates");
            List<NaElement> aggregates = aggregatesElement.GetChildren();

            var aggregateNames = new List<string>();
            foreach (NaElement aggregate in aggregates) {
                aggregateNames.Add(aggregate.GetChildContent("name"));
            }

            this.AggregateNames = aggregateNames;
                
        }

        public override string GetZapiCommandString() {
            return "aggr-list-info";
        }
    }
}
