﻿namespace odct.FilerConfig {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;

    public class AggregatesGetAggregateOptions : Section {
        public string AggregateName;

        public AggregatesGetAggregateOptions(Credentials c, Messenger m, string name)
            : base(c, m) {
            this.AggregateName= name;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("aggregate", this.AggregateName);
            var xo = this.credentials.naServer.InvokeElem(api);
            return xo;
        }

        public override string GetZapiCommandString() {
            return "aggr-options-list-info";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}-{1}", this.GetZapiCommandString(), this.AggregateName);
        }
    }
}
