﻿namespace odct.FilerConfig {
    using System;
    using NetApp.Manage;
    using odct.Settings;

    public class Clock : Section {
        public DateTime FilerCurrentDateTime { get; private set; }

        public Clock(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();
        }

        public override string GetZapiCommandString() {
            return "clock-get-clock";
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var xo = base.Process();
            string timeString = xo.GetChildContent("local-time");
            this.FilerCurrentDateTime = TimeUtil.ConvertFromUnixTime(int.Parse(timeString));
            return xo;
        }
    }
}
