﻿namespace odct.FilerConfig {
    using System;
    using System.Collections.Generic;
    using System.IO;
    using NetApp.Manage;

    public class FilerConfigurationFactory {
        private Credentials credentials;
        private Messenger messenger;
        private FilerConfiguration configuration;

        public FilerConfigurationFactory(Credentials c, Messenger m) {
            this.credentials = c;
            this.messenger = m;
            this.configuration = null;
        }

        public FilerConfiguration Build() {
            if (this.configuration == null) {
                this.configuration = new FilerConfiguration();
                this.configuration.Build(this.credentials, this.messenger);
            }

            return this.configuration;
        }
    }

}
