﻿namespace odct.FilerConfig {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;
    using odct.Clusters;

    public class NodeStorageShelfEnvironmentListInfo: Section {
        public ClusterNode node;

        public NodeStorageShelfEnvironmentListInfo(Credentials c, Messenger m, ClusterNode node)
            : base(c, m) {
            this.node = node;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("node-name", node.nodeName);
            var xo = this.credentials.naServer.InvokeElem(api);
            return xo;
        }

        public override string GetZapiCommandString() {
            return "storage-shelf-environment-list-info";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}", this.GetZapiCommandString());
        }
    }
}
