﻿namespace odct.FilerConfig {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;

    public class StorageAdapterGetAdapterInfo : Section {
        public string AdapterName;

        public StorageAdapterGetAdapterInfo(Credentials c, Messenger m, string name)
            : base(c, m) {
            this.AdapterName = name;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("adapter-name", this.AdapterName);
            var xo = this.credentials.naServer.InvokeElem(api);
            return xo;
        }

        public override string GetZapiCommandString() {
            return "storage-adapter-get-adapter-info";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}-{1}", this.GetZapiCommandString(), this.AdapterName);
        }
    }
}
