﻿namespace odct.FilerConfig {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;

    public class StorageAdapterGetAdapterList : Section {
        public IEnumerable<string> AdapterNames;

        public StorageAdapterGetAdapterList(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement adapterListElement = this.naElement.GetChildByName("adapter-list");
            List<NaElement> adapterElements = adapterListElement.GetChildren();

            var adapterNames = new List<string>();
            foreach (NaElement adapter in adapterElements) {
                adapterNames.Add(adapter.GetChildContent("adapter-name"));
            }
            this.AdapterNames = adapterNames;
        }

        public override string GetZapiCommandString() {
            return "storage-adapter-get-adapter-list";
        }
    }
}
