﻿namespace odct.FilerConfig {
    using System;
    using NetApp.Manage;

    public class SystemCli: Section{
        public const string ZapiCommand = "system-cli";
        private string cliCommand;

        public SystemCli(string cmd, Credentials c, Messenger m) : base(c, m) {
            this.cliCommand = cmd;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var zapiCommand = ZapiCommand;
            this.messenger.sendDebug(string.Format("...GetNaElement(\"{0}\") {1} started.", zapiCommand, this.cliCommand));

            var api = new NaElement(ZapiCommand);
			NaElement argsElement = new NaElement("args");

            foreach (var cli in this.cliCommand.Split(' ')) {
                api.AddChildElement(argsElement);
                argsElement.AddNewChild("arg", cli);
            }

            return this.SafeInvokeElement(api);
        }

        // TODO: only want to customize GetSectionTitle but abstract GetZapiCommandString is required
        public override string GetZapiCommandString() {
            return string.Format("{0}-{1}", ZapiCommand, this.cliCommand.Replace(" ", ""));
        }
    }
}
