﻿namespace odct.FilerConfig {
    using System;
    using System.Text.RegularExpressions;
    using NetApp.Manage;

    public class SystemGetVersion : Section {
        public string SystemVersion { get; private set; }
        public bool Is7Mode { get; private set; }

        public SystemGetVersion(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();
        }

        public override string GetZapiCommandString() {
            return "system-get-version";
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var xo = base.Process(specificZapiCommand);
            var v = xo.GetChildContent("version");
            var m = Regex.Match(v, @"(\d+\.\d+\.\d+)");
            this.SystemVersion = m.Groups[0].Value;

            var m2 = Regex.Match(SystemVersion, @"^\d+");
            var SystemMajorVersion = m2.Groups[0].Value;

            Is7Mode = Regex.IsMatch(v, "7-Mode");

            var clustered = xo.ToString().ToLower().Contains("<is-clustered>true");
            if (clustered) {
                throw new FilerConfigException("cDOT not implemented");
            } else {
                return xo;
            }
        }
    }
}
