﻿namespace odct.FilerConfig {
    using System;
    using System.Collections.Generic;
    using NetApp.Manage;

    public class SystemInfo : Section {
        public string SystemName { get; private set; }
        public string SystemSerialNumber { get; private set; }
        public string SystemModel { get; private set; }
        public string SystemId { get; private set; }
        public string PartnerSystemId { get; private set; }

        public SystemInfo(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement systemElement = this.naElement.GetChildByName("system-info");
            this.SystemName = systemElement.GetChildContent("system-name");
            this.SystemId = systemElement.GetChildContent("system-id");
            this.SystemSerialNumber = systemElement.GetChildContent("system-serial-number");
            this.SystemModel = systemElement.GetChildContent("system-model");
            this.PartnerSystemId = systemElement.GetChildContent("partner-system-id");
        }

        public override string GetZapiCommandString() {
            return "system-get-info";
        }
    }
}
