﻿namespace odct.FilerConfig {
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Xml.XPath;
    using NetApp.Manage;

    public class VolumeGetContainer : Section {
        public string VolumeName;

        public VolumeGetContainer(Credentials c, Messenger m, string name)
            : base(c, m) {
            this.VolumeName = name;
            this.FinishConstructor();
        }

        protected override NaElement Process(string specificZapiCommand = null) {
            var api = new NaElement(this.GetZapiCommandString());
            api.AddNewChild("volume", this.VolumeName);
            var xo = this.credentials.naServer.InvokeElem(api);
            return xo;
        }

        public override string GetZapiCommandString() {
            return "volume-container";
        }

        public override string GetSectionTitle() {
            return string.Format("{0}-{1}", this.GetZapiCommandString(), this.VolumeName);
        }
    }
}
