﻿namespace odct.FilerConfig {
    using System;
    using System.Collections.Generic;
    using NetApp.Manage;

    public class VolumeGetList : Section {
        public IEnumerable<string> VolumeNames;

        public VolumeGetList(Credentials c, Messenger m)
            : base(c, m) {
            this.FinishConstructor();

            NaElement volumesElement = this.naElement.GetChildByName("volumes");
            List<NaElement> volumes = volumesElement.GetChildren();

            var volumeNames = new List<string>();
            foreach (NaElement volume in volumes) {
                volumeNames.Add(volume.GetChildContent("name"));
            }

            this.VolumeNames = volumeNames;
        }

        public override string GetZapiCommandString() {
            return "volume-list-info";
        }
    }
}
