﻿using System;
using System.Collections.Generic;
using System.Text;

namespace odct.Json {
    public class JsonObject : JsonValue {

        private List<KeyValuePair<JsonString,JsonValue>> jsonObjectList;

        public JsonObject() {
            jsonObjectList = new List<KeyValuePair<JsonString,JsonValue>>();        
        }

        public void Add(string s, JsonValue j) {
            jsonObjectList.Add(new KeyValuePair<JsonString, JsonValue>(new JsonString(s), j));
        }

        public void Add(JsonString js, JsonValue jv) {
            jsonObjectList.Add(new KeyValuePair<JsonString, JsonValue>(js, jv));
        }

        public void Add(KeyValuePair<string, JsonValue> kvp) {
            jsonObjectList.Add(new KeyValuePair<JsonString, JsonValue>(new JsonString(kvp.Key), kvp.Value));
        }

        public void Add(KeyValuePair<JsonString, JsonValue> kvp) {
            jsonObjectList.Add(kvp);
        }

        public override string toString() {
            List<string> stringList = new List<string>();
            foreach (KeyValuePair<JsonString, JsonValue> kvp in jsonObjectList) {
                JsonString jsonObjectKey = kvp.Key;
                string jsonValueAsString = kvp.Value.toString();
                string work = string.Format("{0}:{1}", jsonObjectKey.toString(), jsonValueAsString);
                stringList.Add(work);
            }
            string[] kvpStringArray = stringList.ToArray();
            string kvpString = string.Join(",\n", kvpStringArray);
            return string.Format("{0}{1}{2}", "{\n", kvpString, "\n}");
        }
    }
}
