namespace odct {
    using System;
    using System.Collections.Generic;

    public abstract class MessageRecorder : Messenger {

        protected abstract void RecordMessage(string formattedMessage);

        private void sendMessage(string message, string prefix) {
            this.RecordMessage(string.Format("{0} - {1} - {2}", MessageRecorder.timeNow(), prefix, message));
        }

        public override void sendDebug(string message) {
            this.sendMessage(message, "Debug");
        }

        public override void  sendInfo(string message) {
            this.sendMessage(message, "Info");
        }

        public override void  sendWarning(string message) {
            this.sendMessage(message, "Warning");
        }
        
        public override void  sendError(string message) {
            this.sendMessage(message, "Error");
        }

    }
}
