using System;
using System.Collections.Generic;

namespace odct {
    public class MessageRepeater : Messenger {
        Messenger[] messengers;

        public MessageRepeater(Messenger[] m) {
            messengers = m;
        }

        public override void sendDebug(string message) {
            foreach (Messenger messenger in messengers) {
                messenger.sendDebug(message);
            }
        }

        public override void sendInfo(string message) {
            foreach (Messenger messenger in messengers) {
                messenger.sendInfo(message);
            }
        }

        public override void sendWarning(string message) {
            foreach (Messenger messenger in messengers) {
                messenger.sendWarning(message);
            }
        }

        public override void sendError(string message) {
            foreach (Messenger messenger in messengers) {
                messenger.sendError(message);
            }
        }

        public new void sendException(Exception e) {
            foreach (Messenger messenger in messengers) {
                messenger.sendException(e);
            }
        }

        public override void closeMessenger() {
            foreach (Messenger messenger in messengers) {
                messenger.closeMessenger();
            }
        }

        public override void update(updateObject o) {
            foreach (Messenger messenger in messengers) {
                messenger.update(o);
            }
        }
    }
}
