namespace odct {
    using System.IO;

    public class PayloadLogger : MessageRecorder {

        StreamWriter logfile;
        private static readonly object objLock = new object();

        public PayloadLogger(string path) {
            lock (objLock) {
                if (!Directory.Exists(path)) {
                    Directory.CreateDirectory(path);
                }
            }

            lock (objLock) {
                var file = Path.Combine(path, "odct-log.txt");
                if (this.logfile == null) {
                    this.logfile = new StreamWriter(file);
                }
            }
        }

        protected override void RecordMessage(string formattedMessage) {
            lock (objLock) {
                this.logfile.WriteLine(formattedMessage);
                this.logfile.Flush();
            }
        }

        public override void closeMessenger() {
            lock (objLock) {
                this.logfile.Close();
            }
        }

    }
}
