﻿namespace odct.Settings {
    using System;
    using System.Collections.Generic;

    public class TimeUtil {
        private static DateTime dateUnixOrigin = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);

        public static double GetElapsedSeconds(DateTime dateStart) {
            TimeSpan elapsedTime = DateTime.Now - dateStart;
            double elapsed = Math.Floor(elapsedTime.TotalSeconds);

            return elapsed;
        }

        public static double GetElapsedMilliseconds(DateTime dateStart) {
            TimeSpan elapsedTime = DateTime.Now - dateStart;
            double elapsed = Math.Floor(elapsedTime.TotalMilliseconds);

            return elapsed;
        }

        public static double GetUnixTime() {
            TimeSpan spanTime = DateTime.UtcNow - dateUnixOrigin;
            double seconds = spanTime.TotalSeconds;

            return Math.Floor(seconds);
        }

        public static double ConvertToUnixTime(DateTime theDate) {
            TimeSpan spanTime = theDate.ToUniversalTime() - dateUnixOrigin;
            double seconds = spanTime.TotalSeconds;

            return Math.Floor(seconds);
        }

        public static DateTime ConvertFromUnixTime(int unixTime) {
            DateTime date = dateUnixOrigin.AddSeconds(unixTime);

            return date.ToLocalTime();
        }

        public static long GetTimeSlewTicks(DateTime a, DateTime b) {
            return Math.Abs(a.Ticks - b.Ticks);
        }

        public static bool TimeSlewWithinRange(DateTime a, DateTime b, TimeSpan d) {
            return GetTimeSlewTicks(a, b) < d.Ticks;
        }
    }
}
